Index: src/Actions/MoleculeAction/SaveTemperatureAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -47,5 +47,5 @@
     DoLog(1) && (Log() << Verbose(1) << "Storing temperatures in " << params.temperaturefile << "." << endl);
     ofstream output;
-    output.open(params.temperaturefile.c_str(), ios::trunc);
+    output.open(params.temperaturefile.string().c_str(), ios::trunc);
     if (output.fail() || !mol->OutputTemperatureFromTrajectories((ofstream * const) &output, 0, mol->MDSteps))
       DoLog(2) && (Log() << Verbose(2) << "File could not be written." << endl);
@@ -78,7 +78,3 @@
   return false;
 }
-
-const string MoleculeSaveTemperatureAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/SaveTemperatureAction.def
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
 #define paramtokens ("save-temperature")
 #define paramdescriptions ("name of the temperature file to write to")
+#undef paramdefaults
 #define paramreferences (temperaturefile)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
-#define DESCRIPTION "name of the temperature file to write to"
+#define DESCRIPTION "save the temperature per time step to file"
 #define SHORTFORM "S"
-#define TYPEINFO &typeid(std::string)
Index: src/Actions/MoleculeAction/SuspendInWaterAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -77,7 +77,3 @@
   return false;
 }
-
-const string MoleculeSuspendInWaterAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/SuspendInWaterAction.def
===================================================================
--- src/Actions/MoleculeAction/SuspendInWaterAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/MoleculeAction/SuspendInWaterAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (double)
 #define paramtokens ("suspend-in-water")
-#define paramdescriptions ("suspend the given molecule in water such that in the domain the mean density is as specified")
+#define paramdescriptions ("desired final density")
+#undef paramdefaults
 #define paramreferences (density)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "suspend the given molecule in water such that in the domain the mean density is as specified"
 #define SHORTFORM "u"
-#define TYPEINFO &typeid(double)
Index: src/Actions/MoleculeAction/VerletIntegrationAction.cpp
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -48,5 +48,5 @@
     // TODO: sollte besser stream nutzen, nicht filename direkt (es sei denn, ist prefix), besser fuer unit test
     char outputname[MAXSTRINGSIZE];
-    strcpy(outputname, params.forcesfile.c_str());
+    strcpy(outputname, params.forcesfile.string().c_str());
     if (!mol->VerletForceIntegration(outputname, *(World::getInstance().getConfig()), 0))
       DoLog(2) && (Log() << Verbose(2) << "File " << params.forcesfile << " not found." << endl);
@@ -78,7 +78,3 @@
   return false;
 }
-
-const string MoleculeVerletIntegrationAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/MoleculeAction/VerletIntegrationAction.def
===================================================================
--- src/Actions/MoleculeAction/VerletIntegrationAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/MoleculeAction/VerletIntegrationAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
 #define paramtokens ("verlet-integrate")
 #define paramdescriptions ("perform verlet integration of a given force file")
+#undef paramdefaults
 #define paramreferences (forcesfile)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "perform verlet integration of a given force file"
 #define SHORTFORM "P"
-#define TYPEINFO &typeid(std::string)
Index: src/Actions/OptionRegistry.cpp
===================================================================
--- src/Actions/OptionRegistry.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/OptionRegistry.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,112 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * OptionRegistry.cpp
+ *
+ *  Created on: Oct 26, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <boost/shared_ptr.hpp>
+
+#include "Actions/Action.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Actions/ActionTraits.hpp"
+#include "Actions/OptionRegistry.hpp"
+#include "Actions/OptionTrait.hpp"
+#include "Patterns/Singleton_impl.hpp"
+#include "Patterns/Registry_impl.hpp"
+
+/** Constructor for class OptionRegistry.
+ */
+OptionRegistry::OptionRegistry()
+{}
+
+/** Destructor for class OptionRegistry.
+ */
+OptionRegistry::~OptionRegistry()
+{}
+
+/** Just passes on call to Registry<std::type_info>::getByName().
+ * \param name name of Option
+ * \return pointer to Option's type
+ */
+const OptionTrait* OptionRegistry::getOptionByName(const std::string name) const
+{
+  return const_cast<const OptionTrait *>(getByName(name));
+}
+
+/** Initializes options from ActionRegistries contents.
+ * Just goes through all Action's and adds their options.
+ */
+//void OptionRegistry::Init()
+//{
+//  ActionRegistry &AR = ActionRegistry::getInstance();
+//  for (ActionRegistry::const_iterator actioniter = AR.getBeginIter();
+//      actioniter != AR.getEndIter();
+//      ++actioniter) {
+//    Action* const currentAction = actioniter->second;
+//    for (ActionTraits::options_const_iterator optioniter = currentAction->Traits.getBeginIter();
+//        optioniter != currentAction->Traits.getEndIter();
+//        ++optioniter) {
+//      // wrap option in a shared_ptr to have it exist till and automatically removed at end of code
+//      std::string const &OptionName = optioniter->first;
+//      std::type_info const &typeDesired = *((actioniter->second)->Traits.getOptionType(OptionName));
+//      if (isOptionPresentByName(OptionName)) {
+//        std::type_info const &typePresent = *(getOptionByName(OptionName)->getType());
+//        ASSERT( typeDesired == typePresent,
+//            "OptionRegistry::Init() - Two options with same token do not have the same type!");
+//      } else {
+//        registerInstance(new Option(OptionName, &typeDesired));
+//      }
+//    }
+//  }
+//}
+
+/** checking that each of the Actions' options has the same (and present) type in the OptionRegistry.
+ * We use ASSERT
+ */
+void OptionRegistry::ConsistencyCheck()
+{
+  ActionRegistry &AR = ActionRegistry::getInstance();
+  for (ActionRegistry::const_iterator actioniter = AR.getBeginIter();
+      actioniter != AR.getEndIter();
+      ++actioniter) {
+    for (ActionTraits::options_const_iterator optioniter = (actioniter->second)->Traits.getBeginIter();
+        optioniter != (actioniter->second)->Traits.getEndIter();
+        ++optioniter) {
+      std::string const &OptionName = optioniter->first;
+      std::type_info const &typeDesired = *((actioniter->second)->Traits.getOption(OptionName).getType());
+      ASSERT( isOptionPresentByName(OptionName),
+          "ConsistencyCheck() - option token not contained in OptionRegistry");
+      std::type_info const &typePresent = *(getOptionByName(OptionName)->getType());
+      ASSERT( typeDesired == typePresent,
+          "ConsistencyCheck() - Two options with same token do not have the same type!");
+    }
+  }
+};
+
+
+/** Just passes on call to Registry<std::type_info>::isPresentByName().
+ * \param name name of Option
+ * \return true - Option instance present, false - not
+ */
+bool OptionRegistry::isOptionPresentByName(const std::string name) const
+{
+  return isPresentByName(name);
+}
+
+CONSTRUCT_SINGLETON(OptionRegistry)
+CONSTRUCT_REGISTRY(OptionTrait)
Index: src/Actions/OptionRegistry.hpp
===================================================================
--- src/Actions/OptionRegistry.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/OptionRegistry.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,40 @@
+/*
+ * OptionRegistry.hpp
+ *
+ *  Created on: Oct 26, 2010
+ *      Author: heber
+ */
+
+#ifndef OPTIONREGISTRY_HPP_
+#define OPTIONREGISTRY_HPP_
+
+#include "Patterns/Registry.hpp"
+#include "Patterns/Singleton.hpp"
+
+class OptionTrait;
+
+/** Option Registry.
+ *
+ * The Option registry is a storage for any Option of Actions instance to retrieved by name.
+ * It is a singleton and can be called from anywhere.
+ *
+ */
+class OptionRegistry : public Singleton<OptionRegistry>, public Registry<OptionTrait>
+{
+  friend class Singleton<OptionRegistry>;
+
+public:
+  const OptionTrait * getOptionByName(const std::string name) const;
+  bool isOptionPresentByName(const std::string name) const;
+
+  void ConsistencyCheck();
+
+private:
+  OptionRegistry();
+  ~OptionRegistry();
+
+  // initializer called in constructor
+  //void Init();
+};
+
+#endif /* OPTIONREGISTRY_HPP_ */
Index: src/Actions/OptionTrait.cpp
===================================================================
--- src/Actions/OptionTrait.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/OptionTrait.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,155 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * OptionTrait.cpp
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include <iostream>
+#include <typeinfo>
+
+#include <boost/shared_ptr.hpp>
+
+#include "Actions/OptionRegistry.hpp"
+#include "Actions/OptionTrait.hpp"
+
+/** Constructor for class OptionTrait.
+ * note that OptionTrait automatically registers with OptionRegistry.
+ * \param &_token name of option
+ * \param &_type type of option
+ * \param &_description description of what the option is for
+ * \param &_defaultvalue default value, empty string if none
+ * \param &_shortform short form to access option on CommmandLineUI, empty if none
+ * \param *_instance type to be stored in this OptionTrait.
+ */
+OptionTrait::OptionTrait(const std::string &_token, std::type_info const * const _type, const std::string _description, const std::string _defaultvalue, const std::string _shortform) :
+    Token(_token),
+    InternalType(_type),
+    Description(_description),
+    DefaultValue(_defaultvalue),
+    ShortForm(_shortform)
+{
+  std::cout << "OptionTrait::OptionTrait() with " << getName() << ", type " << getTypeName() << " and description " << getDescription() << std::endl;
+}
+
+/** Copy constructor for class OptionTrait.
+ * note that OptionTrait automatically registers with OptionRegistry.
+ * \param &_option reference of option to copy
+ * \param *_instance type to be stored in this OptionTrait.
+ */
+OptionTrait::OptionTrait(const OptionTrait &_option) :
+    Token(_option.getName()),
+    InternalType(_option.getType()),
+    Description(_option.getDescription()),
+    DefaultValue(_option.getDefaultValue()),
+    ShortForm(_option.getShortForm())
+{}
+
+/** Destructor for class OptionTrait.
+ *
+ */
+OptionTrait::~OptionTrait()
+{}
+
+/** Returns Current Value for this ActionTrait.
+ * \return OptionTrait::CurrentValue as std::string
+ */
+const std::string& OptionTrait::getDefaultValue() const
+{
+ return DefaultValue;
+}
+
+/** Returns Description for this ActionTrait.
+ * \return OptionTrait::Description as std::string
+ */
+const std::string& OptionTrait::getDescription() const
+{
+  return Description;
+}
+
+/** Specific Getter for a ActionTrait::ShortForm.
+ * If action has a short for, then combination is as "Token,ShortForm" (this is
+ * the desired format for boost::program_options). If no short form exists in the map,
+ * just Token will be returned
+ * Note that we assert when action does not exist in CommandLineParser::DescriptionMap.
+ * \return ActionTrait::Token,ActionTrait::ShortForm or Description of the action
+ */
+const std::string OptionTrait::getKeyAndShortForm() const
+{
+  std::stringstream output;
+  output << Token;
+  if (hasShortForm())
+    output << "," << ShortForm;
+  return output.str();
+}
+
+
+/** Returns ShortForm for this OptionTrait.
+ * \return OptionTrait::ShortForm as std::string
+ */
+const std::string& OptionTrait::getShortForm() const
+{
+  return ShortForm;
+}
+
+/** Returns Type for this OptionTrait.
+ * \return OptionTrait::InternalType as std::type_info reference
+ */
+const std::type_info * const OptionTrait::getType() const
+{
+  return InternalType;
+}
+
+/** Returns Name of the Type for this OptionTrait.
+ * \return OptionTrait::InternalType->name()
+ */
+const std::string OptionTrait::getTypeName() const
+{
+  return InternalType->name();
+}
+
+/** States whether DefaultValue is present or not.
+ * \return true - DefaultValue unequal to empty string present.
+ */
+bool OptionTrait::hasDefaultValue() const
+{
+  return (!DefaultValue.empty());
+}
+
+/** States whether ShortForm is present or not.
+ * \return true - ShortForm unequal to empty string present.
+ */
+bool OptionTrait::hasShortForm() const
+{
+  return (!ShortForm.empty());
+}
+
+/** Returns token of the option.
+ * \return name/token of option
+ */
+const std::string& OptionTrait::getName() const
+{
+  return Token;
+}
+
+/** Sets the short form to the given value.
+ * \param &_shortform new short form
+ */
+void OptionTrait::setShortForm(const std::string _shortform)
+{
+  ShortForm = _shortform;
+}
Index: src/Actions/OptionTrait.hpp
===================================================================
--- src/Actions/OptionTrait.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/OptionTrait.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,46 @@
+/*
+ * OptionTrait.hpp
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+#ifndef OPTIONTRAIT_HPP_
+#define OPTIONTRAIT_HPP_
+
+#include <string>
+#include <typeinfo>
+
+/** Contains basic information for Options.
+ */
+class OptionTrait
+{
+public:
+  OptionTrait(const std::string &_token, std::type_info const * const _type, const std::string _description, const std::string _defaultvalue = std::string(), const std::string _shortform = std::string());
+  OptionTrait(const OptionTrait &_option);
+  ~OptionTrait();
+
+  // getter for the information contained
+  const std::string& getDefaultValue() const;
+  const std::string& getDescription() const;
+  const std::string getKeyAndShortForm() const;
+  const std::string& getName() const;
+  const std::string& getShortForm() const;
+  const std::type_info * const getType() const;
+  const std::string getTypeName() const;
+
+  // setter for information
+  void setShortForm(const std::string _shortform);
+
+  bool hasDefaultValue() const;
+  bool hasShortForm() const;
+
+protected:
+  const std::string Token;
+  const std::type_info* const InternalType;
+  const std::string Description;
+  const std::string DefaultValue;
+  std::string ShortForm;
+};
+
+#endif /* OPTIONTRAIT_HPP_ */
Index: src/Actions/ParserAction/LoadXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ParserAction/LoadXyzAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -38,8 +38,8 @@
   getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file for new atoms." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "Parsing xyz file " << params.filename << " for new atoms." << endl);
   // parse xyz file
   ifstream input;
-  input.open(params.filename.c_str());
+  input.open(params.filename.string().c_str());
   if (!input.fail()) {
     XyzParser parser; // briefly instantiate a parser which is removed at end of focus
@@ -73,7 +73,3 @@
   return false;
 }
-
-const string ParserLoadXyzAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/ParserAction/LoadXyzAction.def
===================================================================
--- src/Actions/ParserAction/LoadXyzAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ParserAction/LoadXyzAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
 #define paramtokens ("parse-xyz")
-#define paramdescriptions ("parse xyz file into World")
+#define paramdescriptions ("name of xyz file")
+#undef paramdefaults
 #define paramreferences (filename)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "parse xyz file into World"
 #define SHORTFORM "p"
-#define TYPEINFO &typeid(std::string)
Index: src/Actions/ParserAction/SaveXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ParserAction/SaveXyzAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -20,7 +20,7 @@
 #include "Helpers/MemDebug.hpp"
 
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "Parser/XyzParser.hpp"
-#include "atom.hpp"
-#include "molecule.hpp"
 
 #include <iostream>
@@ -41,9 +41,13 @@
   getParametersfromValueStorage();
 
+  DoLog(1) && (Log() << Verbose(1) << "Storing xyz file " << params.filename << "." << endl);
   // store xyz file
   ofstream output;
-  output.open(params.filename.c_str());
-  if (!output.fail())
+  output.open(params.filename.string().c_str());
+  if (!output.fail()) {
     parser.save(&output);
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "Could not open file " << params.filename << "." << endl);
+  }
   output.close();
   return Action::failure;
@@ -73,7 +77,3 @@
   return false;
 }
-
-const string ParserSaveXyzAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/ParserAction/SaveXyzAction.def
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/ParserAction/SaveXyzAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
-#define paramtypes (std::string)
-#define paramtokens ("SaveXyz")
-#define paramdescriptions ("save world as xyz file")
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)
+#define paramtokens ("store-xyz")
+#define paramdescriptions ("file name of xyz file")
+#undef paramdefaults
 #define paramreferences (filename)
 
@@ -25,10 +26,8 @@
 #define MENUPOSITION 2
 #define ACTIONNAME SaveXyz
-#define TOKEN "SaveXyz"
+#define TOKEN "store-xyz"
 
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "save world as xyz file"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/Process.cpp
===================================================================
--- src/Actions/Process.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Process.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -24,6 +24,6 @@
 using namespace std;
 
-Process::Process(int _maxSteps, std::string _name, bool _doRegister) :
-  Action(_name,_doRegister),
+Process::Process(int _maxSteps, const ActionTraits &_trait, bool _doRegister) :
+  Action(_trait,_doRegister),
   Observable("Process"),
   maxSteps(_maxSteps),
Index: src/Actions/Process.hpp
===================================================================
--- src/Actions/Process.hpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/Process.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -40,5 +40,5 @@
 {
 public:
-  Process(int _maxSteps, std::string _name, bool _doRegister=true);
+  Process(int _maxSteps, const ActionTraits &_trait, bool _doRegister=true);
   virtual ~Process();
 
Index: src/Actions/RedoAction.cpp
===================================================================
--- src/Actions/RedoAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/RedoAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,59 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * RedoAction.cpp
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "ActionHistory.hpp"
+
+#include <iostream>
+
+#include "Helpers/Assert.hpp"
+
+#include "Actions/RedoAction.hpp"
+
+// and construct the stuff
+#include "RedoAction.def"
+#include "Action_impl_pre.hpp"
+
+/** =========== define the function ====================== */
+Action::state_ptr RedoAction::performCall(){
+  std::cout << "Redo" << std::endl;
+  ActionHistory::getInstance().redoLast();
+  return Action::success;
+}
+
+Action::state_ptr RedoAction::performUndo(Action::state_ptr){
+  ASSERT(0,"Cannot undo a redo (should use undo for this");
+  return Action::success;
+}
+
+Action::state_ptr RedoAction::performRedo(Action::state_ptr){
+  ASSERT(0,"Cannot redo a redo");
+  return Action::success;
+}
+
+bool RedoAction::canUndo(){
+  return false;
+}
+
+bool RedoAction::shouldUndo(){
+  return false;
+}
+/** =========== end of function ====================== */
Index: src/Actions/RedoAction.def
===================================================================
--- src/Actions/RedoAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/RedoAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,28 @@
+/*
+ * RedoAction.def
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#undef paramtypes
+#undef paramreferences
+#undef paramtokens
+#undef paramdescriptions
+#undef paramdefaults
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#undef CATEGORY 
+#define MENUNAME "edit"
+#define MENUPOSITION 2
+#define ACTIONNAME Redo
+#define TOKEN "redo"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "redo the last action"
+#undef SHORTFORM
Index: src/Actions/RedoAction.hpp
===================================================================
--- src/Actions/RedoAction.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
+++ src/Actions/RedoAction.hpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -0,0 +1,21 @@
+/*
+ * RedoAction.hpp
+ *
+ *  Created on: Oct 27, 2010
+ *      Author: heber
+ */
+
+#ifndef REDOACTION_HPP_
+#define REDOACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Actions/Action.hpp"
+
+#include "RedoAction.def"
+#include "Actions/Action_impl_header.hpp"
+
+#endif /* REDOACTION_HPP_ */
Index: src/Actions/SelectionAction/AllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -72,7 +72,3 @@
   return true;
 }
-
-const string SelectionAllAtomsAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/SelectionAction/AllAtomsAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
 #undef paramdescriptions
+#undef paramdefaults
 #undef paramreferences
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "select all atoms"
 #undef SHORTFORM
-#define TYPEINFO &typeid(void)
Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -86,7 +86,3 @@
   return true;
 }
-
-const string SelectionAllAtomsInsideCuboidAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -13,8 +13,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (Vector)(Vector)(double)(double)(double)
 #define paramtokens ("select-atoms-inside-cuboid")("position")("angle-x")("angle-y")("angle-z")
-#define paramdescriptions ("select all atoms inside a cuboid")("position in R^3 space")("angle of a rotation around x axis")("angle of a rotation around y axis")("angle of a rotation around z axis")
+#define paramdescriptions ("dimensions of cuboid")("position in R^3 space")("angle of a rotation around x axis")("angle of a rotation around y axis")("angle of a rotation around z axis")
+#undef paramdefaults
 #define paramreferences (extension)(position)(Xangle)(Yangle)(Zangle)
 
@@ -31,6 +32,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "select all atoms inside a cuboid"
 #undef SHORTFORM
-#define TYPEINFO &typeid(VectorValue)
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -80,7 +80,3 @@
   return true;
 }
-
-const string SelectionAllAtomsInsideSphereAction::getName() {
-  return NAME;
-}
 /** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.def	(revision 53be342642ecc5d8c92481d78bf7924d629aad3f)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.def	(revision 76cec6c27521e13434c84ce3ad89ba64ea437510)
@@ -11,8 +11,9 @@
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
 #define paramtypes (double)(Vector)
 #define paramtokens ("select-atoms-inside-sphere")("position")
-#define paramdescriptions ("select all atoms inside a sphere")("position in R^3 space")
+#define paramdescriptions ("sphere radius")("position in R^3 space")
+#undef paramdefaults
 #define paramreferences (radius)(position)
 
@@ -29,6 +30,4 @@
 
 // finally the information stored in the ActionTrait specialization
-#undef DEFAULTVALUE
 #define DESCRIPTION "select all atoms inside a sphere"
 #undef SHORTFORM
-#define TYPEINFO &typeid(double)
